#include "Sprite.h"
#include "VVram.h"
#include "Vram.h"

constexpr byte InvalidY = 0xe0;

struct Sprite {
    byte x, y;
    byte[4] chars;
};
Sprite[SpriteCount] Sprites;


void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(byte index, byte x, byte y, ptr<byte> pChars)
{
    ptr<Sprite> p;
    ptr<byte> pDestination;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    pDestination = p->chars;
    repeat(4) {
        *pDestination = *pChars;
        ++pDestination;
        ++pChars;
    }
}


void ShowSpriteC(byte index, byte x, byte y, byte c)
{
    ptr<Sprite> p;
    ptr<byte> pDestination;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    p->chars[0] = c;
    p->chars[1] = Char_Space;
    p->chars[2] = Char_Space;
    p->chars[3] = Char_Space;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pVVram, pChar;
            pVVram = VVramFront + VVramOffset(p->x, p->y);
            pChar = p->chars;
            repeat (2) {
                repeat (2) {
                    byte c;
                    c = *pChar; ++pChar;
                    if (c != Char_Space) {
                        *pVVram = c;
                    }
                    ++pVVram;
                }
                pVVram += VVramWidth - 2;
            }
        }
    }
}
